#line 1 "C:/Users/Viktor/Desktop/uv2_example/AVR/uv2_click_example.c"
#line 1 "c:/c4w/mikroelektronika/mikroc pro for avr/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;



typedef signed char int_fast8_t;
typedef signed int int_fast16_t;
typedef signed long int int_fast32_t;


typedef unsigned char uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned long int uint_fast32_t;


typedef signed int intptr_t;
typedef unsigned int uintptr_t;


typedef signed long int intmax_t;
typedef unsigned long int uintmax_t;
#line 3 "C:/Users/Viktor/Desktop/uv2_example/AVR/uv2_click_example.c"
uint8_t uv2_get_8bit(uint8_t reg)
{
 uint8_t temp = 0;
 TWI_Start();
 TWI_Write(0x20);
 TWI_Write(reg);
 TWI_Stop();
 TWI_Start();
 TWI_WRite(0x21);
 temp = TWI_Read(0);
 TWI_Stop();
}

uint16_t uv2_get_16bit (uint8_t reg)
{
 uint8_t temp[2] = {0};
 uint16_t retval = 0;

 TWI_Start();
 TWI_Write(0x20);
 TWI_Write(reg);
 TWI_Stop();
 TWI_Start();
 TWI_WRite(0x21);
 temp[0] = TWI_Read(0);
 temp[1] = TWI_Read(0);

 retval = (uint16_t) temp[0];
 retval |= ((uint16_t) temp[1]) << 8;
 TWI_Stop();

 return retval;
}

float get_uv_index()
{
 float UVA = 0.0;
 float UVB = 0.0;
 float UVcomp1 = 0.0;
 float UVcomp2 = 0.0;
 float UVD = 0.0;
 float UVAcomp = 0.0;
 float UVBcomp = 0.0;
 float UVI = 0.0;
 float UVAresp = 0.0011;
 float UVBresp = 0.00125;

 float a = 3.33;
 float b = 2.5;
 float c = 3.66;
 float d = 2.75;

 UVA = (float) uv2_get_16bit(0x07);
 UVD = (float) uv2_get_16bit(0x08);
 UVB = (float) uv2_get_16bit(0x09);
 UVcomp1 = (float) uv2_get_16bit(0x0A);
 UVcomp2 = (float) uv2_get_16bit(0x0B);

 UVAcomp = ( UVA - UVD ) - a * ( UVcomp1 - UVD ) - b * ( UVcomp2 - UVD );
 UVBcomp = ( UVB - UVD ) - c * ( UVcomp1 - UVD ) - d * ( UVcomp2 - UVD );

 UVI = ( (UVBcomp * UVBresp) + (UVAcomp * UVAresp) ) / 2;

 return UVI;
}

void InitMCU()
{
 TWI_Init( 100000 );
 Delay_ms(100);
}
void main()
{
 float uvindex = 0.0;
 char read[3];
 uint16_t read16 = 0;
 int setup[3];
 char txt[20];

 Uart1_Init(9600);
 Uart1_Write_Text("Uart initialized \r\n");


 setup[0] = 0x00;
 setup[1] = 0x00;
 setup[2] = 0x00;

 InitMCU();

 TWI_Start();
 TWI_Write(0x20);
 TWI_Write(0x00);
 TWI_Write(0x00);
 TWI_Write(0x00);
 TWI_STop();

 while(1)
 {
 uvindex = get_uv_index();
 floattostr(uvindex, txt);

 Uart1_Write_Text(txt);
 Uart1_Write_Text("\r\n");

 delay_ms(500);
 }

}
